.envrc 6.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241
  1. # This is the .envrc for sentry, for use with direnv.
  2. # It's responsible for enforcing a standard dev environment by checking as much state as possible, and either performing
  3. # initialization (e.g. activating the venv) or giving recommendations on how to reach the desired state.
  4. # It also sets useful environment variables.
  5. # If you'd like to override or set any custom environment variables, this .envrc will read a .env file at the end.
  6. set -e
  7. # Since direnv traps the EXIT signal we place the temp file under /tmp for the odd time
  8. # the script will use the EXIT path
  9. _SENTRY_LOG_FILE=$(mktemp /tmp/sentry.envrc.$$.out)
  10. exec > >(tee "$_SENTRY_LOG_FILE")
  11. exec 2>&1
  12. bold="$(tput bold)"
  13. red="$(tput setaf 1)"
  14. green="$(tput setaf 2)"
  15. yellow="$(tput setaf 3)"
  16. reset="$(tput sgr0)"
  17. # XXX: we can't trap bash EXIT, because it'll override direnv's finalizing routines.
  18. # consequently, using "exit" anywhere will skip this notice from showing.
  19. # so need to use set -e, and return 1.
  20. trap notice ERR
  21. # This is used to group issues on Sentry.io.
  22. # If an issue does not call info() or die() it will be grouped under this
  23. error_message="Unknown issue"
  24. log_level="info"
  25. notice() {
  26. [ $? -eq 0 ] && return
  27. cat <<EOF
  28. ${red}${bold}direnv wasn't able to complete execution.
  29. You may have been given some recommendations in the error message.
  30. Follow them, and then you'll need to redo direnv by running "direnv allow".${reset}
  31. If you're stuck or have questions, ask in #discuss-dev-tooling.
  32. EOF
  33. [ -z "${SENTRY_DEVENV_NO_REPORT+x}" ] && report_to_sentry
  34. }
  35. report_to_sentry() {
  36. if ! require sentry-cli; then
  37. curl -sL https://sentry.io/get-cli/ | bash
  38. fi
  39. SENTRY_DSN=${SENTRY_DEVENV_DSN} \
  40. sentry-cli send-event -m "$error_message" --logfile "$_SENTRY_LOG_FILE" --level $log_level
  41. rm "$_SENTRY_LOG_FILE"
  42. }
  43. require() {
  44. command -v "$1" >/dev/null 2>&1
  45. }
  46. warn() {
  47. cat <<EOF
  48. ${yellow}${bold}direnv: ${@}${reset}
  49. EOF
  50. }
  51. info() {
  52. cat <<EOF
  53. ${bold}direnv: ${@}${reset}
  54. EOF
  55. # info() calls happen multiple times in this script. The last info statement
  56. # is the one that will be used to group Sentry issues
  57. error_message=( "${@}" )
  58. }
  59. die() {
  60. cat >&2 <<EOF
  61. ${red}${bold}direnv FATAL: ${@}
  62. ${reset}
  63. EOF
  64. # When reporting to Sentry, this will allow grouping the errors differently
  65. # NOTE: The first line of the output is used to group issues
  66. error_message=( "${@}" )
  67. log_level="error"
  68. return 1
  69. }
  70. advice_init_venv() {
  71. venv_name="$1"
  72. deactivate 2>/dev/null || true
  73. info "To create a virtualenv, please type: python3.6 -m venv ${venv_name}"
  74. require "python3.6" ||
  75. die "You'll need to install python3, or make it available on your PATH.
  76. It's recommended to use pyenv - please refer to https://docs.sentry.io/development/contribute/environment"
  77. return 1
  78. }
  79. advice_install_sentry() {
  80. info "To install sentry, please type: make install-py-dev"
  81. return 1
  82. }
  83. advice_install_pre_commit() {
  84. info "To install pre-commit, please type: make setup-git"
  85. return 1
  86. }
  87. advice_install_yarn_pkgs() {
  88. info "To install yarn packages, please type: make install-js-dev"
  89. return 1
  90. }
  91. ### Environment ###
  92. # don't write *.pyc files; using stale python code occasionally causes subtle problems
  93. export PYTHONDONTWRITEBYTECODE=1
  94. # Always write stdout immediately. Very helpful for debugging
  95. export PYTHONUNBUFFERED=1
  96. # make sure we don't have any conflicting PYTHONPATH
  97. unset PYTHONPATH
  98. # don't check pypi for a potential new pip version; low-hanging fruit to save a bit of time
  99. export PIP_DISABLE_PIP_VERSION_CHECK=on
  100. # increase node's memory limit, required for our webpacking
  101. export NODE_OPTIONS=--max-old-space-size=4096
  102. # Frontend hot module reloader using `react-refresh`
  103. # Enable this by default for development envs (CI/deploys do not use envrc)
  104. export SENTRY_UI_HOT_RELOAD=1
  105. ### You can override the exported variables with a .env file
  106. # All exports should happen before here unless they're safeguarded (see devenv error reporting below)
  107. if [ -f '.env' ]; then
  108. info ".env found. Reading it..."
  109. dotenv .env
  110. fi
  111. ## Notify of reporting to Sentry
  112. if [ -n "${SENTRY_DEVENV_NO_REPORT+x}" ]; then
  113. info "No development environment errors will be reported (since you've defined SENTRY_DEVENV_NO_REPORT)."
  114. else
  115. info "Development errors will be reported to Sentry.io."$'\n'" If you wish to opt-out, set SENTRY_DEVENV_NO_REPORT as an env variable."
  116. export SENTRY_DEVENV_DSN=https://23670f54c6254bfd9b7de106637808e9@o1.ingest.sentry.io/1492057
  117. fi
  118. ### System ###
  119. for pkg in \
  120. make \
  121. docker \
  122. chromedriver \
  123. pkg-config \
  124. pyenv \
  125. openssl; do
  126. if ! require "$pkg"; then
  127. die "You seem to be missing the system dependency: ${pkg}
  128. Please install homebrew, and run brew bundle."
  129. fi
  130. done
  131. ### Git ###
  132. info "Configuring git..."
  133. make setup-git-config
  134. ### Python ###
  135. venv_name=".venv"
  136. info "Activating virtualenv..."
  137. if [ ! -f "${venv_name}/bin/activate" ]; then
  138. info "You don't seem to have a virtualenv."
  139. # If the version doesn't match the contents of .python-version it will fail
  140. [[ $(pyenv version) ]] || \
  141. die "pyenv does not have the right Python version installed. Please run:
  142. make setup-pyenv && python3.6 -m venv ${venv_name}"
  143. advice_init_venv "$venv_name"
  144. fi
  145. # The user might be cd'ing into sentry with another non-direnv managed
  146. # (in that it would be automatically deactivated) virtualenv active.
  147. deactivate 2>/dev/null || true
  148. source "${venv_name}/bin/activate"
  149. # XXX: ideally, direnv is able to export PS1 as modified by sourcing venvs
  150. # but we'd have to patch direnv, and ".venv" isn't descriptive anyways
  151. unset PS1
  152. info "Ensuring proper virtualenv..."
  153. ${PWD}/scripts/ensure-venv.sh
  154. if ! require sentry; then
  155. info "Your virtualenv is activated, but sentry doesn't seem to be installed."
  156. # XXX: if direnv fails, the venv won't be activated outside of direnv execution...
  157. # So, it is critical that make install-py-dev is guarded by scripts/ensure-venv.
  158. advice_install_sentry
  159. fi
  160. ### pre-commit ###
  161. info "Checking pre-commit..."
  162. if ! require pre-commit; then
  163. info "Looks like you don't have pre-commit installed."
  164. advice_install_pre_commit
  165. fi
  166. ### Node ###
  167. info "Checking node..."
  168. if ! require node; then
  169. die "You don't seem to have node installed. Install volta (a node version manager): https://develop.sentry.dev/environment/#javascript"
  170. fi
  171. make node-version-check
  172. if [ ! -x "node_modules/.bin/webpack" ]; then
  173. info "You don't seem to have yarn packages installed."
  174. advice_install_yarn_pkgs
  175. fi
  176. PATH_add node_modules/.bin
  177. ### Overrides ###
  178. cat <<EOF
  179. ${green}${bold}direnv: SUCCESS!
  180. ${reset}
  181. EOF
  182. if [ -z "${SENTRY_SILENCE_DIRENV_NOTICE:-}" ]; then
  183. cat <<EOF
  184. If you're stuck or have questions, ask in #discuss-dev-tooling.
  185. EOF
  186. fi
  187. # Since we can't use an EXIT routine we need to guarantee we delete the file here
  188. rm "$_SENTRY_LOG_FILE"